﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			Loaded += new RoutedEventHandler(TileView1_Loaded);
		}

		void TileView1_Loaded(object sender, RoutedEventArgs e)
		{
			this.radTileView.ItemsSource = Enumerable.Range(0, 5);

			this.Dispatcher.BeginInvoke(new Action(() =>
			{
				foreach (var item in this.radTileView.Items)
				{
					this.UpdateFluid(this.radTileView.ItemContainerGenerator.ContainerFromItem(item) as RadTileViewItem);
				}
			}));
		}

		private void tileView1_TileStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			try
			{
				e.Handled = true;
				UpdateFluid(e.OriginalSource as RadTileViewItem);
			}
			catch (Exception ex) { }
		}

		private void UpdateFluid(RadTileViewItem item)
		{
			if (item != null)
			{
				var fluidControls = item.ChildrenOfType<RadFluidContentControl>();
				if (fluidControls.Count == 0)
				{
					return;
				}
				RadFluidContentControl fluidControl = fluidControls[0];

				switch (item.TileState)
				{
					case TileViewItemState.Maximized:
						fluidControl.State = FluidContentControlState.Large;
						break;
					case TileViewItemState.Minimized:
						fluidControl.State = FluidContentControlState.Small;
						break;
					case TileViewItemState.Restored:
						fluidControl.State = FluidContentControlState.Normal;
						break;
				}
			}
		}
	}
}
